//+------------------------------------------------------------------+
//|                                             selfteachingma2.mq4  |

//+------------------------------------------------------------------+
#property copyright "labryant"


//---- input parameters
extern int atr1=9;
extern int atr2=18;
extern int maxLots=100;
extern double Lots=1; 
extern int reinv=10; 
extern int multiPos=10;
extern double pipval1a=0.0100;
extern double pipval2a=0.0200;
extern double       tp = 20;
extern double       sl = 70;
extern int          magic = 051207;
static int          prevtime = 0;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {

  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----

   if (Time[0] == prevtime) return(0);
   prevtime = Time[0];

   int total = OrdersTotal();
   for (int i = 0; i < total; i++) {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == magic) {
         return(0);
      }
   }
   
if(OrdersTotal()<1)
{
calcVal1();
calcVal2();
}


   double main0 = iMA(Symbol(),0,calcVal1(),0,0,0,0);
   double signal0 = iMA(Symbol(),0,calcVal2(),0,0,0,0);
    double main1 = iMA(Symbol(),0,calcVal1(),0,0,1,0);
   double signal1 = iMA(Symbol(),0,calcVal2(),0,0,1,0);

   if(Lots<(MathCeil((AccountFreeMargin()/1000)*reinv)/10)){Lots=(MathCeil((AccountFreeMargin()/10000)*reinv)/10);if(Lots>maxLots){Lots=maxLots;}}
   if (main1 > signal1 && main0 < signal0) {

      OrderSend(Symbol(), OP_SELL, Lots, Bid, 3, Ask + sl * Point, Ask - tp * Point, "selfteachingma", magic, 0, Red); 
   }
   if (main1 < signal1 && main0>signal0) {
 
      OrderSend(Symbol(), OP_BUY, Lots, Ask, 3, Bid - sl * Point, Bid + tp * Point, "selfteachingma", magic, 0, Blue); 
   }
   
   
//----
   return(0);
  }
//+------------------------------------------------------------------+

double calcVal1()
{
double totalbar=0;
double totalbarcumal=0;
double totalbarold=0;
double pipval1=pipval1a;
double pipval2=pipval2a;
int stepsback1=0;
int stepsback2=0;

totalbar=0;
totalbarcumal=0;
totalbarold=0;

for(int i2=0; totalbarcumal<pipval1; i2++)
{
totalbarold=totalbar;

totalbar=High[i2]-Low[i2];
totalbarcumal=totalbarold+totalbar;
stepsback1=i2;

}
return(stepsback1);
}

double calcVal2()
{
double totalbar=0;
double totalbarcumal=0;
double totalbarold=0;
double pipval1=pipval1a;
double pipval2=pipval2a;
int stepsback1=0;
int stepsback2=0;
totalbar=0;
totalbarcumal=0;
totalbarold=0;

for(int i3=0; totalbarcumal<pipval2; i3++)
{
totalbarold=totalbar;

totalbar=High[i3]-Low[i3];
totalbarcumal=totalbarold+totalbar;
stepsback2=i3;

}
return(stepsback2);
}

